const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class TransactionsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const transactions = await db.transactions.create(
      {
        id: data.id || undefined,

        amount: data.amount || null,
        transaction_date: data.transaction_date || null,
        transaction_type: data.transaction_type || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await transactions.setAccount(data.account || null, {
      transaction,
    });

    await transactions.setKooperatif(data.kooperatif || null, {
      transaction,
    });

    return transactions;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const transactionsData = data.map((item, index) => ({
      id: item.id || undefined,

      amount: item.amount || null,
      transaction_date: item.transaction_date || null,
      transaction_type: item.transaction_type || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const transactions = await db.transactions.bulkCreate(transactionsData, {
      transaction,
    });

    // For each item created, replace relation files

    return transactions;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const transactions = await db.transactions.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.amount !== undefined) updatePayload.amount = data.amount;

    if (data.transaction_date !== undefined)
      updatePayload.transaction_date = data.transaction_date;

    if (data.transaction_type !== undefined)
      updatePayload.transaction_type = data.transaction_type;

    updatePayload.updatedById = currentUser.id;

    await transactions.update(updatePayload, { transaction });

    if (data.account !== undefined) {
      await transactions.setAccount(
        data.account,

        { transaction },
      );
    }

    if (data.kooperatif !== undefined) {
      await transactions.setKooperatif(
        data.kooperatif,

        { transaction },
      );
    }

    return transactions;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const transactions = await db.transactions.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of transactions) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of transactions) {
        await record.destroy({ transaction });
      }
    });

    return transactions;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const transactions = await db.transactions.findByPk(id, options);

    await transactions.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await transactions.destroy({
      transaction,
    });

    return transactions;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const transactions = await db.transactions.findOne(
      { where },
      { transaction },
    );

    if (!transactions) {
      return transactions;
    }

    const output = transactions.get({ plain: true });

    output.account = await transactions.getAccount({
      transaction,
    });

    output.kooperatif = await transactions.getKooperatif({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userKooperatif = (user && user.kooperatif?.id) || null;

    if (userKooperatif) {
      if (options?.currentUser?.kooperatifId) {
        where.kooperatifId = options.currentUser.kooperatifId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.accounts,
        as: 'account',

        where: filter.account
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.account
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  account_type: {
                    [Op.or]: filter.account
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.kooperatif,
        as: 'kooperatif',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.amountRange) {
        const [start, end] = filter.amountRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            amount: {
              ...where.amount,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            amount: {
              ...where.amount,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.transaction_dateRange) {
        const [start, end] = filter.transaction_dateRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            transaction_date: {
              ...where.transaction_date,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            transaction_date: {
              ...where.transaction_date,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.transaction_type) {
        where = {
          ...where,
          transaction_type: filter.transaction_type,
        };
      }

      if (filter.kooperatif) {
        const listItems = filter.kooperatif.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          kooperatifId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.kooperatifId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.transactions.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('transactions', 'transaction_type', query),
        ],
      };
    }

    const records = await db.transactions.findAll({
      attributes: ['id', 'transaction_type'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['transaction_type', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.transaction_type,
    }));
  }
};
